gnushogi(6)

NAME
gnushogi - GNU Shogi (Japanese Chess)

SYNOPSIS
gnushogi [ [[-]a] [-b bookfile] [-B binbookfile] [-C] [-h langfile] [-L langfile] [-r length] [-R] [-s pathname] [-l pathname] [-S binbooksize] [-t] [-c size] [-T size] [-v] [-x] [-X] arg1 arg2 ]

DESCRIPTION
Gnushogi plays a game of japanese chess (shogi) against the user or it plays against itself.

At startup Gnushogi reads the binbook file if it is present. It then looks for a book file. If it is present it adds its contents to the binbook data. If the binbook file is writable a new combined binbook file is written.

Gnushogi is a modified version of the gnuchess program. It has a simple alphanumeric board display, or it can be compiled for use with the xshogi program under X windows. The program gets its opening moves from the file gnushogi.bbk which is located in a directory specified in the Makefile. To invoke the program type:

gnushogi -C
    - simple curses based version

gnushogi -X (or just gnushogi)
    - xshogi compatible version

gnushogi -R
    - raw test display version

TIME CONTROLS

If one argument is given, it is the search time per move in [minutes:]seconds. So gnushogi 30 will generate one move every 30 seconds, while gnushogi 5:00 will generate one move every 5 minutes. If two or more arguments are given, they will be used to set tournament time controls with the first argument of each pair being the number of moves and the second being the total clock time in minutes[:seconds]. Thus, entering gnushogi 60 5 will set the clocks for 5 minutes (300 seconds) for the first 60 moves, and gnushogi 30 3:30 will allow 3 minutes and 30 seconds for 30 moves. gnushogi 30 5 1 :30 will allow 5 minutes for the first 30 moves and 30 seconds for each move after that. Up to 4 pairs of controls may be specified. If no argument is given the program will prompt the user for level of play. For use with xshogi see the documentation on that program.

BOOK

The book gnushogi.tbk consists of a sequence of openings. An opening begins with a line starting with a # , the rest of the line is a comment. Following this is a series of moves in algebraic notation alternating black and white separated by white space. A move may have a ? after it indicating this move should never be made in this position. Moves are stored as position:move so transpositions between openings can take place.

HASHFILE

The hashfile if created should be on the order of 4 megabytes or gnushogi -c 22. This file contains positions and moves learned from previous games. If a hashfile is used the computer makes use of the experience it gained in past games. Tests run so far show that it plays no worse with the hashfile than without, but it is not clear yet whether it provides a real advantage.

LEGAL MOVES

Note: Piece letters are determined by the language file. What is specified here is the default (English).

Once gnushogi is invoked, the program will display the board and prompt the user for a move. To enter a move, use the notation 7g7f where the first letter-number pair indicates the origin square and the second letter-number pair indicates the destination square. An alternative is to use the notation P7f where the first letter indicates the piece type (P,L,N,S,G,B,R,K). To promote append a + the type of the new piece to the move, as in 2d2c+ or P2c+. Note that you must use capital letters for the pieces by default.

COMMAND-LINE OPTIONS

-a  Do not search on opponent's time.

a   Do search on opponent's time.

-b bookfile
    Use bookfile for opening book.

-B binbookfile
    Use binbookfile for binary opening book.

-c size
    Create a new HASHFILE. File size is 2^size entries of approximately 65+? bytes.

-C  Use curses-based display mode.

-h  Do not use hashfile.

h   Do use hashfile.

-l pathname
    Pathname of the loadfile use with get or xget.

-L lang
    Use language lang from the file gnushogi.lang. If -L is not specified it uses the first language in the file.

-P plylevels
    Number of plys to include in the binbookfile. For generating a binbookfile.

-r length
    Rehash length times in searching entries for position in transposition table.

-R  Use raw text display mode. This can be used for dumb terminals or for systems that don't have curses.

-s pathname
    Pathname of the save file to use with the save command.

-S size
    Size of binbookfile for memory based books. For creating a binbookfile.

-t  Show statistics for HASHFILE

-T size
    Set the transposition table size to 2^size entries.

-v  Show version and patchlevel.

-x value
    Use value as the evaluation window xwndw.

-X  Use xshogi display mode (the default).

COMMANDS

In addition to legal moves, the following commands are available as responses. Note: command names are determined by the language file and may vary with the implementation. The default language is English.

alg -- allow algebraic input (not implemented)

Awindow -- change Alpha window (default score + 90)

Bwindow -- change Beta window (default score - 90)

beep -- toggles beeping after each move (default: on).

bd -- updates the current board position on the display.

book -- turns off use of the opening library.

both -- causes the computer to play both sides of a shogi game.

black -- causes the computer to take the white pieces, if the computer is to move first.

bsave -- saves a game to disk as a book textfile. The program will prompt the user for a file name.

gamein -- toggles game mode time control. Assumes the time specified for time control is the time for a complete game. Input with the level command should be the game time and the expected number of moves in a game. go command must be given.

contempt -- allows the value of contempt to be modified.

debug -- asks for a piece as color piece, as wb or bn, and shows its calculated value on each square.

debuglevel -- sets level of debugging output if compiled with debug options.

depth -- allows the user to change the search depth of the program. The maximum depth is 29 ply. Normally the depth is set to 29 and the computer terminates its search based on elapsed time rather than depth. If depth is set to (say) 4 ply, the program will search until all moves have been examined to a depth of 4 ply (with extensions up to 11 additional ply for sequences of checks and captures). If you set a maximum time per move and also use the depth command, the search will stop at the specified time or the specified depth, whichever comes first.

easy -- toggles easy mode (thinking on opponents time) on and off. The default is easy mode ON. If easy mode is disabled, the keyboard is polled for input every so often and when input is seen the search is terminated. It may also be terminated with a sigint.

edit -- allows the user to set up a board position. # - command will clear the board. c - toggle piece color. . - command will exit setup mode. p3b - place a pawn on 3b p3b+ - place a promoted pawn on 3b p* - place a pawn to the captured pieces Pieces are entered by typing a letter (p,l,n,s,g,b,r,k) for the piece followed by the coordinate. The usual warning about the language file applies.

exit -- exits gnushogi.

first -- tells the computer to move first. Computer begins searching for a move. (same as "go").

force -- allows the user to enter moves for both sides. To get the program to play after a sequence of moves has been entered use the 'black' or 'white' commands.

get -- retrieves a game from disk. The program will prompt the user for a file name.

hash -- use/don't use hashfile.

hashdepth -- allows the user to change the minimum depth for using the hashfile and the number of moves from the beginning of the game to use it.

help -- displays a short description of the commands and the current status of options.

go -- tells the computer to move first. Computer begins searching for a move. (same as "first").

hint -- causes the program to supply the user with its predicted move.

level -- allows the user to set time controls such as 60 moves in 5 minutes etc. In tournament mode, the program will vary the time it takes for each move depending on the situation. If easy mode is disabled (using the 'easy' command), the program will often respond with its move immediately, saving time on its clock for use later on.

list -- writes the game moves and some statistics on search depth, nodes, and time to the file 'shogi.lst'.

material -- toggle material flag - draws on no pawns and both sides < rook

new -- starts a new game.

p -- evaluates the board and shows the point score for each piece. The total score for a position is the sum of these individual piece scores.

post -- causes the program to display the principal variation and the score during the search. A score of 100 is equivalent to a 1 pawn advantage for the computer.

quit -- exits the game.

random -- causes the program to randomize its move selection slightly.

rcptr -- set recapture mode.

remove -- backout the last level for both sides. Equal to 2 undo's.

reverse -- causes the board display to be reversed. That is, the black pieces will now appear at the top of the board.

save -- saves a game to disk. The program will prompt the user for a file name.

switch -- causes the program to switch places with the opponent and begin searching.

test -- performs some speed tests for MoveList and CaptureList generation, and ScorePosition position scoring for the current board.

time -- set computer's time remaining, intended for synchronizing clocks among multiple players.

tsume -- toggle tsume mode. In tsume mode, not all possible moves will be generated. If a king is in check, only moves that get the king out of check are generated. If the king is not in check, only moves that give check to the opponent's king are generated.

undo -- undoes the last move whether it was the computer's or the human's. You may also type "remove". This is equivalent to two "undo"'s (e.g. retract one move for each side).

white -- causes the computer to take the black pieces, if the computer is to move first the go command must be given.

xget -- read an xshogi position file.

xsave -- save as an xshogi position file.

xwndw -- change X window. The window around alpha/beta used to determine whether the position should be scored or just estimated.

BUGS

SEE ALSO
xshogi(6)